
; ========================================================
;			
;    -- NewGL.asm --
;			- Savage
; ========================================================
  
.586
.MODEL FLAT,STDCALL
OPTION CASEMAP:NONE
 			
;------------------------------------------------
;               Header
;------------------------------------------------

	;----------------------------
	;     Includes
	;----------------------------
		
		include NewGL.inc
		
	;----------------------------
	;     Prototypes
	;----------------------------
		
		WinMain PROTO :DWORD,:DWORD,:DWORD,:DWORD
		WndProc PROTO :HWND, :UINT, :WPARAM, :LPARAM
		ReSizeGLScene PROTO dwWidth:DWORD, dwHeight:DWORD 
		CreateGLWindow PROTO lpsTitle:DWORD, dwWidth:DWORD, dwHeight:DWORD, dwBits:DWORD, boolFullscreen:BOOL
		KillGLWindow PROTO
		DrawGLScene PROTO
		InitGL PROTO
		LoadGLTexture PROTO
;------------------------------------------------
;                .CODE
;------------------------------------------------
.CODE

	Start:
		invoke GetModuleHandle, NULL
		mov hInstance,eax
		invoke GetCommandLine
		mov CommandLine, eax
		invoke WinMain, hInstance, NULL, CommandLine, SW_SHOWDEFAULT
		invoke ExitProcess,eax
		

;------------------------------------------------
;  Texture stuff
;------------------------------------------------

;------------------------------------------------
; Load bitmap 
;------------------------------------------------
LoadGLTexture PROC
  LOCAL hBMP:DWORD, ImgInfo:BITMAP
	static texture dword 0
  
    invoke LoadImage, hInstance, starBmp, IMAGE_BITMAP  , 0, 0, LR_CREATEDIBSECTION 
   .if eax!=0
	    mov hBMP, eax
	    invoke GetObject, hBMP, sizeof BITMAP, ADDR ImgInfo
	    
  		invoke glGenTextures, 1, ADDR texture
	    invoke glBindTexture, GL_TEXTURE_2D, texture
	    invoke glTexParameteri, GL_TEXTURE_2D, GL_TEXTURE_MAG_FILTER, GL_LINEAR
	    invoke glTexParameteri, GL_TEXTURE_2D, GL_TEXTURE_MIN_FILTER, GL_LINEAR
	    invoke glTexImage2D, GL_TEXTURE_2D, 0, 3, ImgInfo.bmWidth, ImgInfo.bmHeight,\
	                         0, GL_RGB, GL_UNSIGNED_BYTE, ImgInfo.bmBits
	    
	  ; invoke  gluBuild2DMipmaps,GL_TEXTURE_2D, 3, ImgInfo.bmWidth, ImgInfo.bmHeight, GL_RGB, GL_UNSIGNED_BYTE, ImgInfo.bmBits
	    
	    
	    mov eax, TRUE
	.else
		invoke MessageBox,0,$String("Load bitmap failed!"),$String("ERROR"),MB_OK or MB_ICONEXCLAMATION
	.endif
    ret
LoadGLTexture ENDP

;---------------------------------------------------------------------------
; Stars setup
;---------------------------------------------------------------------------

	star STRUCT
		;rgba dd ?
		 r db ?
		 g db ?
		 b db ?
		 a db ?
		 dist  real4 ?		;Stars Distance From Center
		 angle real4 ? 		;Stars Current Angle
	star ENDS
	STARCOUNT equ 50
.data? 

	stars star STARCOUNT dup(<?>) 

.data

	zoom REAL4 -15.0 ; Viewing Distance Away From Stars
	tilt REAL4  90.0 ; Tilt The View
	spin REAL4   0.0 ; Spin Twinkling Stars

.code
	
		
		
;------------------------------------------------
;   Here's Where We Do All The Drawing
;------------------------------------------------

DrawGLScene PROC uses edi
LOCAL StarLoop:DWORD
	;---------------------------------------------------------------------------
	; Clear
	;---------------------------------------------------------------------------
		
		invoke glClear, GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT  	; Clear The Screen And The Depth Buffer
		invoke glBindTexture,GL_TEXTURE_2D, texture
				
				
				
	;---------------------------------------------------------------------------
	; Loop through stars
	;---------------------------------------------------------------------------
		
						
		mov StarLoop, 0
		xor edi, edi
	InitStars:
	;----------------------------------
	; Set up parameters
	;----------------------------------
		invoke glLoadIdentity
		
		Translate 0.0, 0.0, zoom
		Rotate    tilt, 1.0, 0.0, 0.0  ; Tilt the view
		
		Rotate    stars[edi].star.angle, 0.0, 1.0, 0.0 ;  Rotate To The Current Star's Angle
		Translate stars[edi].star.dist,  0.0, 0.0      ; Move Forward On The X Plane

;btr stars[edi].star.angle,31
;btr tilt,31

		mov eax,  stars[edi].star.angle
		btr eax, 31;xor eax, 080000000h			; Negate
		Rotate eax, 0.0,  1.0, 0.0	; Cancel The Current Stars Angle
		
		mov eax,  tilt
		btr eax, 31;xor eax, 080000000h			; Negate
		Rotate eax, 1.0, 0.0, 0.0	; Cancel The Screen Tilt

	
;----------------------------------
; Draw
;----------------------------------

	
		Rotate spin, 0.0, 0.0, 1.0 		;Rotate The Star On The Z Axis
		; Assign A Color Using Bytes
		invoke glColor4ub, stars[edi].star.r, stars[edi].star.g, stars[edi].star.b, 255
		;invoke glColor4ub, 255, 14, 129, 255
		
		
		invoke glBegin,GL_QUADS ;  Begin Drawing The Textured Quad
			TextureVertex 0.0, 0.0, -1.0,-1.0, 0.0
			TextureVertex 1.0, 0.0,  1.0,-1.0, 0.0
			TextureVertex 1.0, 1.0,  1.0, 1.0, 0.0
			TextureVertex 0.0, 1.0, -1.0, 1.0, 0.0
		invoke glEnd			;  Done Drawing The Textured Quad


	;----------------------------------
	; Update Parameters
	;----------------------------------
	;spin+=0.01f		;Used To Spin The Stars
		fld spin
		fadd $float(0.01)
		fstp spin
		
	;stars[loop].angle+=float(StarLoop)/num;		// Changes The Angle Of A Star
		fild StarLoop
		fidiv $Const(STARCOUNT)
		fadd stars[edi].star.angle
		fstp  stars[edi].star.angle
	;stars[loop].dist-=0.01f;				// Changes The Distance Of A Star
		fld stars[edi].star.dist
		fsub $float(0.01)
		fstp stars[edi].star.dist
		
	
	;----------------------------------
	; Remake star if dist < 0
	;----------------------------------
	
		;test stars[edi].star.dist, 080000000h
		;jz @F
		;	fld $float(5.0)
		;	fadd stars[edi].star.dist
		;	fstp stars[edi].star.dist
			;stars[loop].r=rand()%256;		// Give It A New Red Value
			;stars[loop].g=rand()%256;		// Give It A New Green Value
			;stars[loop].b=rand()%256;		// Give It A New Blue Value
		;@@:

	
	
		add edi,      (Sizeof star)
		add StarLoop, 1
		
		cmp edi, STARCOUNT*(Sizeof star)
		jb InitStars
		
		
	;---------------------------------------------------------------------------
	; Variables
	;---------------------------------------------------------------------------
	
		comment ^
		.data
		filter	DWORD	1 ; type of filter
		
		xpos	real4	0.0
		ypos	real4	0.0
		zpos	real4	-6.0
		
		xspeed	real4	 0.0		; X Rotation Speed
		yspeed	real4	 0.0		; Y Rotation Speed
		zspeed	real4	 0.0		; Z Rotation Speed
		
		LightAmbient  real4 0.5, 0.5, 0.5, 1.0 ; Ambient Light Values
		LightDiffuse  real4 1.0, 1.0, 1.0, 1.0 ; Diffuse Light Values 
		LightPosition real4 0.0, 0.0, 2.0, 1.0 ; Light Position 
		.code
		
		Translate xpos,ypos,zpos

		static xrot real4 0.0 ; X Rotation
			fld xspeed
			fadd xrot
			fstp xrot
		static yrot real4 0.0 ; Y Rotation
			fld yspeed
			fadd yrot
			fstp yrot
		static zrot real4 0.0 ; Z Rotation
			fld zspeed
			fadd zrot
			fstp zrot

			
	;---------------------------------------------------------------------------
	; Draw Box
	;---------------------------------------------------------------------------
		
			Rotate xrot,1.0,0.0,0.0
			Rotate yrot,0.0,1.0,0.0
			Rotate zrot,0.0,0.0,1.0



		invoke glBegin,GL_QUADS
		;front
		invoke glNormal3f, $float(0.0), $float(0.0),$float(1.0)
			TextureVertex 0.0, 0.0,    -1.0,-1.0, 1.0
			TextureVertex 1.0, 0.0,     1.0,-1.0, 1.0
			TextureVertex 1.0, 1.0,     1.0, 1.0, 1.0
			TextureVertex 0.0, 1.0,    -1.0, 1.0, 1.0
		;back
		invoke glNormal3f, $float(0.0), $float(0.0),$float(-1.0)
			TextureVertex 1.0, 0.0,    -1.0,-1.0,-1.0
			TextureVertex 1.0, 1.0,    -1.0, 1.0,-1.0
			TextureVertex 0.0, 1.0,     1.0, 1.0,-1.0
			TextureVertex 0.0, 0.0,     1.0,-1.0,-1.0
		;top
		invoke glNormal3f, $float(0.0), $float(1.0),$float(0.0)
			TextureVertex 0.0, 1.0,    -1.0, 1.0,-1.0
		    TextureVertex 0.0, 0.0,    -1.0, 1.0, 1.0
		    TextureVertex 1.0, 0.0,     1.0, 1.0, 1.0
		    TextureVertex 1.0, 1.0,     1.0, 1.0,-1.0
		    
		;bottom 
		invoke glNormal3f, $float(0.0), $float(-1.0),$float(0.0)
			TextureVertex 1.0, 1.0,    -1.0,-1.0,-1.0
		    TextureVertex 0.0, 1.0,     1.0,-1.0,-1.0
		    TextureVertex 0.0, 0.0,     1.0,-1.0, 1.0
		    TextureVertex 1.0, 0.0,    -1.0,-1.0, 1.0
		;right
		invoke glNormal3f, $float(1.0), $float(0.0),$float(0.0)
		    TextureVertex 1.0, 0.0,     1.0,-1.0,-1.0
		    TextureVertex 1.0, 1.0,     1.0, 1.0,-1.0
		    TextureVertex 0.0, 1.0,     1.0, 1.0, 1.0
		    TextureVertex 0.0, 0.0,     1.0,-1.0, 1.0
		  ;left
		invoke glNormal3f, $float(-1.0), $float(0.0),$float(0.0)
		    TextureVertex 0.0, 0.0,    -1.0,-1.0,-1.0
		    TextureVertex 1.0, 0.0,    -1.0,-1.0, 1.0
		    TextureVertex 1.0, 1.0,    -1.0, 1.0, 1.0
		    TextureVertex 0.0, 1.0,    -1.0, 1.0,-1.0
		    
		invoke glEnd
		
	;---------------------------------------------------------------------------
	; Draw Square
	;---------------------------------------------------------------------------
		^

	;------------------------------------
	; Done.
	;------------------------------------
		
		mov eax, TRUE
		ret
		
DrawGLScene ENDP 

;------------------------------------------------
;	WinMain
;------------------------------------------------
WinMain PROC hInst:HINSTANCE,hPrevInst:HINSTANCE,CmdLine:LPSTR,CmdShow:DWORD
LOCAL msg:MSG
LOCAL done:BOOL
	mov done, FALSE
	

		;-----------------------------
		;	Fullscreen mode?
		;-----------------------------
		
			invoke MessageBox,0,$String("Would You Like To Run In Fullscreen Mode?"), $String("Start FullScreen?"),MB_YESNO or MB_ICONQUESTION
			.if eax == IDNO
				mov fullscreen,FALSE
			.endif

		;-----------------------------
		;	Create window
		;-----------------------------
			invoke CreateGLWindow,Offset WindowTitle,640,480,16,fullscreen
			.if eax==0
				ret
			.endif

		;-----------------------------
		;	Message Loop
		;-----------------------------
		.while done==FALSE
			
				;------------------------------------------------
				;	Check message, and 
				;------------------------------------------------
				
					invoke PeekMessage, ADDR msg,NULL,0,0,PM_REMOVE 
					.if eax != 0
						.if msg.message == WM_QUIT
							mov done, TRUE
						.else
							invoke TranslateMessage, ADDR msg
							invoke DispatchMessage,  ADDR msg
						.endif
						jmp ContinueMessageLoop
					.endif
				
				;------------------------------------------------
				;	Draw The Scene, and check for escape
				;------------------------------------------------
				
					.if active != FALSE
						.if byte ptr keys[VK_ESCAPE] != FALSE		
							mov done, TRUE	; ESC  was Pressed
						.else
							invoke DrawGLScene			; Draw The Scene
							invoke SwapBuffers,hDC		; Swap Buffers (Double Buffering)
						.endif
					.endif
					
;----------------------------------------------------------------------
;	Keyboard
;----------------------------------------------------------------------
			
			
		;-------------------------------------------------------
		;	Flagged keys.  :: These keys are single press keys.
		;-------------------------------------------------------

			
				;------------------------------------------------
				;	(flags)
				;------------------------------------------------
				
				static bSettings DWORD 0
							bSettingsFullscreen equ 0
							bSettingsLight equ 1
							bSettingsBlend equ 2
				
				;------------------------------------------------
				;	F1 =  toggle fullscreen mode
				;------------------------------------------------
				
					.if byte ptr keys[VK_F1]
						mov byte ptr keys[VK_F1], FALSE
						invoke KillGLWindow
						xor eax, eax
						btc bSettings,bSettingsFullscreen
						adc eax,0
						invoke CreateGLWindow,Offset WindowTitle,640,480,16,eax
						.if eax == 0
							ret
						.endif
					.endif
					
				;------------------------------------------------
				;	L = toggle lighting
				;------------------------------------------------
				
				;MapKeyToFlag VK_L, bSettingsLight
				
					.if byte ptr keys[VK_L]
						mov byte ptr keys[VK_L] , FALSE
						btc bSettings,bSettingsLight
						.if CARRY?
							invoke glDisable,GL_LIGHTING
						.else
							invoke glEnable,GL_LIGHTING
						.endif
					.endif
					
				;------------------------------------------------
				;	B = toggle blending
				;------------------------------------------------
				
					.if byte ptr keys[VK_B] 
						mov byte ptr keys[VK_B] , FALSE
						btc bSettings,bSettingsBlend
						.if CARRY?
							invoke glEnable,GL_BLEND		; Turn Blending On
							invoke glDisable,GL_DEPTH_TEST	; Turn Depth Testing Off
						.else
							invoke glDisable,GL_BLEND		; Turn Blending Off
							invoke glEnable,GL_DEPTH_TEST	; Turn Depth Testing On
						.endif
					.endif
					
		;-------------------------------------------------------
		;	Variable Mapped keys.  :: These keys are hold-down keys.
		;-------------------------------------------------------
				MapKeyToVariable MACRO key,var,increment
					.if byte ptr keys[key] 
						fld $float(increment)
						fadd var
						fstp var
					.endif
				ENDM
				
				comment ^
				MapKeyToVariable VK_LEFT,  yspeed,-0.05
				MapKeyToVariable VK_RIGHT, yspeed, 0.05
				MapKeyToVariable VK_UP,    xspeed,-0.05 
				MapKeyToVariable VK_DOWN,  xspeed, 0.05
				
				MapKeyToVariable VK_W, zpos,-0.05
				MapKeyToVariable VK_S, zpos, 0.05
				MapKeyToVariable VK_A, xpos,-0.05
				MapKeyToVariable VK_D, xpos, 0.05
				^
					
				
					
			ContinueMessageLoop:
			.endw
			BreakMessageLoop:

	invoke KillGLWindow		; Kill The Window
	mov eax, msg.wParam
	ret
WinMain ENDP

;------------------------------------------------
;	WndProc
;------------------------------------------------
WndProc PROC hwnd:HWND, uMsg:UINT, wParam:WPARAM, lParam:LPARAM

	mov eax, uMsg
	;------------------------------------------------
	 .if eax==WM_ACTIVATE
	;------------------------------------------------
		test wParam, 0FFFF0000h ; High word == 0000 ?
		setz al
		and eax, 1
		mov active, eax		
		jmp ExitZero
	;------------------------------------------------
	.elseif eax== WM_SYSCOMMAND
	;------------------------------------------------
		cmp wParam, SC_SCREENSAVE	; If screen saver
		je ExitZero
		cmp wParam, SC_MONITORPOWER ; Or if monitor
		je ExitZero
	;------------------------------------------------
	.elseif eax== WM_KEYDOWN
	;------------------------------------------------
		mov eax, wParam
		mov byte ptr keys[eax], TRUE
		jmp ExitZero
	;------------------------------------------------
	.elseif eax== WM_KEYUP
	;------------------------------------------------
		mov eax, wParam
		mov byte ptr keys[eax], FALSE
		jmp ExitZero
	;------------------------------------------------
	.elseif eax== WM_SIZE
	;------------------------------------------------
	
		movzx eax, word ptr [lParam]
		movzx ecx, word ptr [lParam+2]
		invoke ReSizeGLScene, eax, ecx
		jmp ExitZero
	;------------------------------------------------
	.elseif eax== WM_CLOSE
	;------------------------------------------------
		invoke PostQuitMessage,0
		jmp ExitZero
	.endif
	
	;------------------------------------------------
	; Default window proc
	;------------------------------------------------
		
		invoke DefWindowProc,hwnd,uMsg,wParam,lParam
		
	;------------------------------------
	; Done, continue program.
	;------------------------------------
	
		ret
		
	;------------------------------------
	; Done, exit program.
	;------------------------------------
	
	ExitZero:
		xor eax, eax
		ret
		
WndProc ENDP

;------------------------------------------------
;	Resize And Initialize The GL Window
;------------------------------------------------
ReSizeGLScene PROC dwWidth:DWORD, dwHeight:DWORD 
LOCAL dRatio:real8


	;---------------------------------------------------------------------------
	; Check dwHeight for 0
	;---------------------------------------------------------------------------
		
		mov eax, dwHeight
		test eax,eax   ; If eax == 0
		setz cl
		and ecx, 1
		or eax, ecx
		mov dwHeight, eax
		
		
	;---------------------------------------------------------------------------
	; Reset Viewport, and Projection Matrix
	;---------------------------------------------------------------------------
		
		invoke glViewport,0,0,dwWidth,dwHeight	; Reset The Current Viewport
		invoke glMatrixMode, GL_PROJECTION   	; Select The Projection Matrix
		invoke glLoadIdentity  					; Reset The Projection Matrix
		
	;---------------------------------------------------------------------------
	; Calculate The Aspect Ratio Of The Window
	;---------------------------------------------------------------------------
		
		fild dwWidth
		fidiv dwHeight
		fstp dRatio
		
	;---------------------------------------------------------------------------
	; Reset Perspective, and Modelview Matrix
	;---------------------------------------------------------------------------
		
		invoke gluPerspective,$dConst(45.0),dRatio,$dConst(0.1),$dConst(100.0)
		invoke glMatrixMode,GL_MODELVIEW ; Select The Modelview Matrix
		invoke glLoadIdentity 			 ; Reset The Modelview Matrix
		
	;------------------------------------
	; Done.
	;------------------------------------
		
		ret
		
ReSizeGLScene ENDP

;------------------------------------------------
;   All Setup For OpenGL Goes Here
;------------------------------------------------
InitGL PROC
LOCAL StarLoop:DWORD, RNDM:REAL4, TEMPVAL:DWORD
rdtsc

	mov RNDM, eax
	invoke LoadGLTexture
	.if eax==0
		mov eax, FALSE
		ret
	.endif
	;---------------------------------------------------------------------------
	; Color and Shade
	;---------------------------------------------------------------------------
		
   		invoke glEnable, GL_TEXTURE_2D
		invoke glShadeModel, GL_SMOOTH	; Enables Smooth Shading
		invoke glClearColor, $float(0.0), $float(0.0), $float(0.0), $float(0.5)
		
	;---------------------------------------------------------------------------
	; Depth
	;---------------------------------------------------------------------------
		
		invoke glClearDepth, $double(1.0)	; Depth Buffer Setup
		;invoke glEnable,GL_DEPTH_TEST		; Enables Depth Testing
		;invoke glDepthFunc,GL_LEQUAL		; The Type Of Depth Test To Do
		
	;---------------------------------------------------------------------------
	; Perspective
	;---------------------------------------------------------------------------
		
		invoke glHint, GL_PERSPECTIVE_CORRECTION_HINT, GL_NICEST	; Really Nice Perspective Calculations
		
		
	;---------------------------------------------------------------------------
	; Lighting
	;---------------------------------------------------------------------------
		comment ^
		invoke glLightfv, GL_LIGHT1, GL_AMBIENT, ADDR LightAmbient 	; Setup The Ambient Light
		invoke glLightfv, GL_LIGHT1, GL_DIFFUSE, ADDR LightDiffuse
		invoke glLightfv, GL_LIGHT1, GL_POSITION, ADDR LightPosition
		invoke glEnable, GL_LIGHT1
		^
		
	;---------------------------------------------------------------------------
	; Blending
	;---------------------------------------------------------------------------
		
		
		invoke glBlendFunc,GL_SRC_ALPHA,GL_ONE ; Blending Function For Translucency Based On Source Alpha Value 
		invoke glEnable, GL_BLEND
	
	;---------------------------------------------------------------------------
	; Star Loop
	;---------------------------------------------------------------------------
		
		
		mov StarLoop, 0
		xor ecx, ecx
	InitStars:
		;---------------------------
		; Calculate Angle
		;---------------------------
			fldz
			fstp stars[ecx].star.angle
		;---------------------------
		; Calculate Distance
		;---------------------------
			fild StarLoop
			fmul $float(5.0)
			fidiv $Const(STARCOUNT)
			fstp stars[ecx].star.dist
		;---------------------------
		; Calculate Colors
		;---------------------------
		;---------------
		; Change rndm
		;---------------
		add RNDM, eax
		ror RNDM, cl
		xor eax, RNDM
		mov RNDM, eax
		mov byte ptr stars[ecx].star.r, al
		mov byte ptr stars[ecx].star.g, ah
		mov byte ptr stars[ecx].star.b, cl
			;fist stars[ecx].star.r
			;fist stars[ecx].star.g
			;fistp stars[ecx].star.b
		
		
		add ecx,     (Sizeof star)
		add StarLoop, 1
		
		cmp ecx, STARCOUNT*(Sizeof star)
		jb InitStars
	;------------------------------------
	; Done.
	;------------------------------------
		
		mov eax, TRUE
		ret
		
InitGL ENDP

;------------------------------------------------
;   Do most of the window setup stuff.
;------------------------------------------------
CreateGLWindow PROC lpsTitle:DWORD, dwWidth:DWORD, dwHeight:DWORD, dwBits:DWORD, boolFullscreen:BOOL

LOCAL	PixelFormat:DWORD,	; Holds The Results After Searching For A Match
		wc:WNDCLASS,		; Windows Class Structure
		dwExStyle:DWORD,	; Window Extended Style
		dwStyle:DWORD,		; Window Style
		WindowRect:RECT	,	; Grabs Rectangle Upper Left / Lower Right Values
		dmScreenSettings:DEVMODE	; Fullscreen Mode variables:	
		
	;---------------------------------------------------------------------------
	;  Set up variables
	;---------------------------------------------------------------------------
		
		; Set window coordinates:
		mov WindowRect.left,0
		mov WindowRect.top,0
		mov eax,dwWidth
		mov WindowRect.right, eax
		mov ecx, dwHeight
		mov WindowRect.bottom, ecx
		
		; Set The Global Fullscreen Flag:
		mov edx, boolFullscreen
		mov fullscreen, edx
		
	;---------------------------------------------------------------------------
	; Set up Window Class
	;---------------------------------------------------------------------------
		
		invoke GetModuleHandle,0
		mov hInstance, eax
		mov eax, hInstance
		mov wc.hInstance, eax
		mov wc.lpfnWndProc, Offset WndProc
		mov wc.lpszClassName, Offset GLClassName
		mov wc.lpszMenuName,0
		mov wc.cbClsExtra,0
		mov wc.cbWndExtra,0	
		mov wc.hbrBackground,0
		mov wc.style, CS_HREDRAW or CS_VREDRAW or CS_OWNDC ;	 Redraw On Move, And Own DC For Window
		invoke LoadIcon, 0, IDI_APPLICATION
		mov wc.hIcon,eax
		invoke LoadCursor,0, IDC_ARROW
		mov wc.hCursor, eax

	;---------------------------------------------------------------------------
	; Register Window Class
	;---------------------------------------------------------------------------
		
		invoke RegisterClass,ADDR wc
		.if eax==0 
			invoke MessageBox,0,$String("Failed To Register The Window Class."),$String("ERROR"),MB_OK or MB_ICONINFORMATION
			mov eax,FALSE
			ret
		.endif
		
		.if fullscreen != 0
		;---------------------------------------------------------------------------
		; Prepare for fullscreen mode
		;---------------------------------------------------------------------------

			invoke	RtlZeroMemory, ADDR dmScreenSettings, Sizeof dmScreenSettings

			
			mov dmScreenSettings.dmSize, Sizeof dmScreenSettings  ; Size Of The Devmode Structure
			m3m dmScreenSettings.dmPelsWidth,dwWidth	;	Selected Screen Width
			m3m dmScreenSettings.dmPelsHeight,dwHeight	;	Selected Screen Height
			m3m dmScreenSettings.dmBitsPerPel,dwBits	;	Selected Bits Per Pixel
			mov dmScreenSettings.dmFields, DM_BITSPERPEL or DM_PELSWIDTH or DM_PELSHEIGHT
			
		;---------------------------------------------------------------------------
		; Switch to Fullscreen mode
		;---------------------------------------------------------------------------

			invoke ChangeDisplaySettings, ADDR dmScreenSettings, CDS_FULLSCREEN 
			.if eax!=DISP_CHANGE_SUCCESSFUL
				
				;---------------------------------------------------------------------------
				; Fullscreen mode  failed, offer to quit
				;---------------------------------------------------------------------------
					invoke MessageBox,0,$String("The Requested Fullscreen Mode Is Not Supported By\nYour Video Card. Use Windowed Mode Instead?"),$String("NeHe GL"),MB_YESNO or MB_ICONEXCLAMATION
					.if eax == IDYES
						mov fullscreen, FALSE
					.else
						invoke MessageBox,0,$String("Program Will Now Close."),$String("ERROR"),MB_OK or MB_ICONSTOP
						 mov eax, FALSE
						ret
					.endif
					
			.endif
			
			
		.endif
		
		;---------------------------------------------------------------------------
		; Set style of window according to whether we're in fullscreen mode
		;---------------------------------------------------------------------------
			
			.if fullscreen != 0
				mov dwExStyle,WS_EX_APPWINDOW	; Window Extended Style
				mov dwStyle,WS_POPUP			; Windows Style
				invoke ShowCursor,FALSE			; Hide Mouse Pointer
			.else
				mov dwExStyle,WS_EX_APPWINDOW or WS_EX_WINDOWEDGE	; Window Extended Style
				mov dwStyle,WS_OVERLAPPEDWINDOW		; Windows Style
			.endif
			
			invoke AdjustWindowRectEx, ADDR WindowRect, dwStyle, FALSE, dwExStyle ; Adjust Window To True Requested Size
			
		;---------------------------------------------------------------------------
		; Establish PIXELFORMATDESCRIPTOR
		;---------------------------------------------------------------------------
			
			mov eax, dwBits
			mov pfd.PIXELFORMATDESCRIPTOR.cColorBits, al
			
		;---------------------------------------------------------------------------
		; Macro to quit if eax == false
		;---------------------------------------------------------------------------

			GL_ASSERT MACRO string
			.if eax==0
				invoke KillGLWindow	;; Reset The Display
				invoke MessageBox,0,$String(&string&),$String("ERROR"),MB_OK or MB_ICONEXCLAMATION
				mov eax, FALSE
				ret
			.endif
			ENDM
		;---------------------------------------------------------------------------
		; Create the window!
		;---------------------------------------------------------------------------
			
			mov eax, WindowRect.right
			sub eax, WindowRect.left
			mov ecx, WindowRect.bottom
			sub ecx, WindowRect.top
			mov edx, dwStyle
			or edx, WS_CLIPSIBLINGS or WS_CLIPCHILDREN
			
			invoke CreateWindowEx,dwExStyle, Offset GLClassName, lpsTitle, edx, 0, 0, eax, ecx,0,0, hInstance,0
			mov hWnd, eax
			GL_ASSERT "Window Creation Error."
			
		;------------------------------------
		; Create GL Context Device
		;------------------------------------
			
			invoke GetDC, hWnd
			mov hDC, eax
			GL_ASSERT "Can't Create A GL Device Context."
			
		;------------------------------------
		; Choose Pixel Format
		;------------------------------------
			
			invoke ChoosePixelFormat,hDC,Offset pfd
			mov PixelFormat, eax
			GL_ASSERT "Can't Find A Suitable PixelFormat."
			
			
		;------------------------------------
		; Set Pixel Format
		;------------------------------------
			
			invoke SetPixelFormat,hDC,PixelFormat,Offset pfd
			GL_ASSERT "Can't Set The PixelFormat."
			
		;------------------------------------
		; Create Rendering Context
		;------------------------------------
			
			invoke wglCreateContext, hDC
			mov hRC, eax
			GL_ASSERT "Can't Create A GL Rendering Context."
			
		;------------------------------------
		; Make the Rendering Context active
		;------------------------------------
			
			invoke wglMakeCurrent,hDC,hRC
			GL_ASSERT "Can't Activate The GL Rendering Context."
			
		;------------------------------------
		; Display the window
		;------------------------------------
			invoke ShowWindow,hWnd,SW_SHOW			; Show The Window
			invoke SetForegroundWindow,hWnd			; lightly Higher Priority
			invoke SetFocus,hWnd					; Sets Keyboard Focus To The Window
			invoke ReSizeGLScene,dwWidth, dwHeight	; Set Up Our Perspective GL Screen
			
		;------------------------------------
		; InitGL
		;------------------------------------
			
			invoke InitGL
			GL_ASSERT "Initialization Failed."
			
			
		;------------------------------------
		; Done.
		;------------------------------------
			
			mov eax, TRUE
			ret
			
CreateGLWindow ENDP

;------------------------------------------------
;   Properly Kill The Window
;------------------------------------------------
KillGLWindow PROC

	;---------------------------------------------------------------------------
	; If in fullscreen mode, switch back to desktop.
	;---------------------------------------------------------------------------
	
		.if fullscreen 		; Are We In Fullscreen Mode?
			invoke ChangeDisplaySettings,NULL, 0	; If So Switch Back To The Desktop
			invoke ShowCursor,TRUE					; Show Mouse Pointer
		.endif
		
	;---------------------------------------------------------------------------
	; Release Rendering Context (hRC), or display error.
	;---------------------------------------------------------------------------
	
		.if hRC!=0			; Do We Have A Rendering Context?
			invoke wglMakeCurrent,0,0 
			.if eax==0 	
				invoke MessageBox,0,$String("Release Of DC And RC Failed."),$String("SHUTDOWN ERROR"),MB_OK or MB_ICONINFORMATION
			.endif
			invoke wglDeleteContext,hRC	
			.if eax==0 		
				invoke MessageBox,0,$String("Release Rendering Context Failed."),$String("SHUTDOWN ERROR"),MB_OK or MB_ICONINFORMATION
			.endif
			mov hRC, 0
		.endif
		
	;---------------------------------------------------------------------------
	; Release Device Context (hDC), or display error.
	;---------------------------------------------------------------------------
	
		.if hDC!=0			; Do We Have A Device Context?
			invoke ReleaseDC,hWnd,hDC
			.if eax==0 	
				invoke MessageBox,0,$String("Release Device Context Failed."),$String("SHUTDOWN ERROR"),MB_OK or MB_ICONINFORMATION
				mov hDC, 0
			.endif
		.endif
		
	;---------------------------------------------------------------------------
	; Destroy Window (hWnd), or display error.
	;---------------------------------------------------------------------------
	
		.if hWnd!=0
			invoke DestroyWindow,hWnd
			.if eax==0 		
				invoke MessageBox,0,$String("Could Not Release hWnd."),$String("SHUTDOWN ERROR"),MB_OK or MB_ICONINFORMATION
				mov hWnd, 0
			.endif
		.endif
		
	;---------------------------------------------------------------------------
	;  Unregister Window Class (hInstance)
	;---------------------------------------------------------------------------
	
		invoke UnregisterClass,Offset GLClassName, hInstance
		.if eax==0 
			invoke MessageBox,0,$String("Could Not Unregister Class."),$String("SHUTDOWN ERROR"),MB_OK or MB_ICONINFORMATION
			mov hInstance, 0
		.endif
		
	;------------------------------------
	; Done.
	;------------------------------------
		
		ret
		
KillGLWindow ENDP

End Start